# THIS IS A VERY QUICK AND DIRTY JUMP INTO PYTHON3
# very incomprehensive
# no in depth treatment, just the very fundamentals!

# two main containers
# 1.
tuple = (1, 2, 3) # cannot be modified
# acces 2nd element
tuple[2]
# access last element
tuple[-1]

# our workhorse for today:
list = ['string', 2, 2.1, [1, 2]]
list[-1]
# a list can store everything, even another list

# create a sequence (attention, range() is an iterator in Python3!)
# thus we need to unpack it with * in a list literal []
list = [*range(1, 11)]

# or we could just fill up the list like that
list = []
for i in range(1, 11):
    list.append(i)

# slicing the list
list[0:3]

# add lists
list = list + list

# some operations on lists
len(list)
sorted(list)
# or use the method directly on the object (very pythonic!) instead of list = sorted(list)
list.sort()

# A VERY PYTHONIC THING: List Comprehensions

[x for x in list]
[x + 10 for x in list]

[x**2 for x in range(10)]

# we can add a logical condition
[x for x in list if x > 5]

# or just pick the even numbers
[x for x in list if x % 2 == 0]

# we are not using NumPy arrays or Pandas dataframes (which are the workhorses if you want to do the full workflow in Python)
# also there are dictionaries, a more special type of container

# we can also just add something with each iteration
count = 0
for i in range(10):
    count += i
    print(count)
    